# This script is an edited version of the example found at
# https://git.ligo.org/lscsoft/example-ci-project/blob/python/.gitlab-ci.yml
# Each 0th-indentation level is a job that will be run within GitLab CI
# The only exception are a short list of reserved keywords
#
# https://docs.gitlab.com/ee/ci/yaml/#gitlab-ci-yml

# stages is a reserved keyword that defines job dependencies and
# parallelization. each stage runs in parallel but must complete
# before the next stage begins

stages:
  - test
  - deploy

# test example on python 2
python-2.7:
  stage: test
  image: bilbydev/bilby-test-suite-python27
  before_script:
    # Install the dependencies specified in the Pipfile
    - pipenv install --two --python=/opt/conda/bin/python2 --system --deploy
  script:
    - python setup.py install
    # Run tests without finding coverage
    - pytest --ignore=test/utils_py3_test.py

# test example on python 3
python-3.7:
  stage: test
  image: bilbydev/bilby-test-suite-python37
  before_script:
    # Install the dependencies specified in the Pipfile
    - pipenv install --three --python=/opt/conda/bin/python --system --deploy
  script:
    - python setup.py install

    # Run pyflakes
    - flake8 .

    # Run tests and collect coverage data
    - pytest --cov=bilby
    - coverage html
    - coverage-badge -o coverage_badge.svg -f

    # Make the documentation
    - cd docs
    - make clean
    - make html

  artifacts:
    paths:
      - htmlcov/
      - coverage_badge.svg
      - docs/_build/html/

pages:
  stage: deploy
  dependencies:
    - python-3.7
    - python-2.7
  script:
    - mkdir public/
    - mv htmlcov/ public/
    - mv coverage_badge.svg public/
    - mv docs/_build/html/* public/
  artifacts:
    paths:
      - public
    expire_in: 30 days
  only:
    - master
